const path = require('path');

module.exports = {
  root: false,
  extends: ['airbnb', 'prettier', 'plugin:jsx-a11y/recommended'],
  parser: 'babel-eslint',
  parserOptions: {
    ecmaVersion: 8,
    ecmaFeatures: {
      experimentalObjectRestSpread: true,
      impliedStrict: true,
      classes: true,
      jsx: true,
    },
  },
  env: {
    browser: true,
    node: true,
    jquery: true,
    jest: true,
  },
  rules: {
    'no-return-await': 'off',
    'react/prop-types': 0,
    'react-hooks/rules-of-hooks': 'error',
    'no-debugger': 0,
    'no-alert': 0,
    'no-unused-vars': 1,
    'prefer-const': [
      'error',
      {
        destructuring: 'all',
      },
    ],
    'arrow-body-style': [2, 'as-needed'],
    'no-unused-expressions': [
      2,
      {
        allowTaggedTemplates: true,
      },
    ],
    'no-param-reassign': [
      2,
      {
        props: false,
      },
    ],
    'no-console': 0,
    'import/prefer-default-export': 0,
    'import/no-named-default': 0,
    import: 0,
    'func-names': 0,
    'space-before-function-paren': 0,
    'comma-dangle': 0,
    'class-methods-use-this': 0,
    'max-len': 0,
    'import/extensions': 0,
    'no-underscore-dangle': 0,
    'consistent-return': 0,
    'react/display-name': 1,
    'react/no-array-index-key': 0,
    'react/react-in-jsx-scope': 0,
    'react/prefer-stateless-function': 0,
    'react/forbid-prop-types': 0,
    'react/jsx-props-no-spreading': 0,
    'react/no-unescaped-entities': 0,
    'jsx-a11y/accessible-emoji': 0,
    'react/require-default-props': 0,
    'jsx-a11y/label-has-associated-control': ['error', { assert: 'either' }],
    'react/jsx-max-props-per-line': [1, { when: 'multiline' }],
    'react/jsx-filename-extension': [
      1,
      {
        extensions: ['.js', '.jsx'],
      },
    ],
    radix: 0,
    'no-shadow': [
      2,
      {
        hoist: 'all',
        allow: ['resolve', 'reject', 'done', 'next', 'err', 'error'],
      },
    ],
    quotes: [
      2,
      'single',
      {
        avoidEscape: true,
        allowTemplateLiterals: true,
      },
    ],
    'prettier/prettier': [
      'error',
      {
        trailingComma: 'es5',
        singleQuote: true,
        printWidth: 120,
      },
    ],
    'jsx-a11y/href-no-hash': 'off',
    'jsx-a11y/anchor-is-valid': [
      'warn',
      {
        aspects: ['invalidHref'],
      },
    ],
  },
  plugins: ['prettier', 'react', 'react-hooks', 'import'],
  settings: {
    'import/resolver': {
      alias: {
        map: [
          ['@app', path.resolve(__dirname, './src/components/@app')],
          ['utilities', path.resolve(__dirname, './src/utilities')],
          ['actions', path.resolve(__dirname, './src/redux/actions')],
          ['assets', path.resolve(__dirname, './src/assets')],
          ['validators', path.resolve(__dirname, './src/validators')],
          ['configs', path.resolve(__dirname, './src/configs')],
          ['CONSTANTS', path.resolve(__dirname, './src/constants')],
        ],
        extensions: ['.js', '.jsx', '.png', '.jpg', 'svg'],
      },
    },
  },
  globals: {
    throwError: 'readonly',
  },
};
